diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
index c4b41b2e2..a7b9dfd7b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelActivator.java
@@ -2,11 +2,12 @@ package net.minecraft.client.render.block.model;
 
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
-import net.minecraft.core.block.BlockActivator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicActivator;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelActivator extends BlockModelVeryRotatable<BlockActivator> {
+public class BlockModelActivator<T extends BlockLogic> extends BlockModelVeryRotatable<T> {
     public final IconCoordinate[] poweredTextures = {
         TextureRegistry.getTexture("minecraft:block/activator/bottom_active"),
         TextureRegistry.getTexture("minecraft:block/activator/top_active"),
@@ -23,7 +24,7 @@ public class BlockModelActivator extends BlockModelVeryRotatable<BlockActivator>
         TextureRegistry.getTexture("minecraft:block/activator/side_active_overlay"),
         TextureRegistry.getTexture("minecraft:block/activator/side_active_overlay")
     };
-    public BlockModelActivator(Block block) {
+    public BlockModelActivator(Block<T> block) {
         super(block);
     }
 
@@ -35,7 +36,7 @@ public class BlockModelActivator extends BlockModelVeryRotatable<BlockActivator>
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        if ((data & BlockActivator.MASK_POWERED) != 0) {
+        if ((data & BlockLogicActivator.MASK_POWERED) != 0) {
             return poweredTextures[getTextureIndex(side, data)];
         } else {
             return super.getBlockTextureFromSideAndMetadata(side, data);
@@ -45,7 +46,7 @@ public class BlockModelActivator extends BlockModelVeryRotatable<BlockActivator>
     @Override
     public IconCoordinate getBlockOverbrightTextureFromSideAndMeta(Side side, int data)
     {
-        boolean isPowered = (data & BlockActivator.MASK_POWERED) != 0;
+        boolean isPowered = (data & BlockLogicActivator.MASK_POWERED) != 0;
         if (!isPowered) return null;
         return overbrightTextures[getTextureIndex(side, data)];
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
index 96f9e0069..a7f25cb71 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAlgae.java
@@ -5,12 +5,13 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelAlgae<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelAlgae(Block block) {
+public class BlockModelAlgae<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelAlgae(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
index e2d25efd2..94842cfef 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelAxisAligned.java
@@ -3,21 +3,22 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.BlockAxisAligned;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicAxisAligned;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.helper.Sides;
 
-public class BlockModelAxisAligned<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelAxisAligned(Block block) {
+public class BlockModelAxisAligned<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelAxisAligned(Block<T> block) {
         super(block);
     }
 
     @Override
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        Axis axis = BlockAxisAligned.metaToAxis(meta);
+        Axis axis = BlockLogicAxisAligned.metaToAxis(meta);
         switch(axis)
         {
             case Y:
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
index 59bf3ca95..b95b4ed92 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBasket.java
@@ -4,13 +4,13 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockBasket;
+import net.minecraft.core.block.BlockLogicBasket;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 
-public class BlockModelBasket<T extends BlockBasket> extends BlockModelStandard<T> {
+public class BlockModelBasket<T extends BlockLogicBasket> extends BlockModelStandard<T> {
     protected IconCoordinate fillTexture = TextureRegistry.getTexture("minecraft:block/basket/fill");
-    public BlockModelBasket(Block block) {
+    public BlockModelBasket(Block<T> block) {
         super(block);
     }
 
@@ -44,7 +44,7 @@ public class BlockModelBasket<T extends BlockBasket> extends BlockModelStandard<
         bounds.set(0.0f, 0.0f, 0.0f, 1.0f, 1.0f, 1.0f);
         renderBlocks.renderBitMask = 0;
 
-        final int height = block.getFillLevel(renderBlocks.blockAccess, x, y, z);
+        final int height = block.getLogic().getFillLevel(renderBlocks.blockAccess, x, y, z);
         // Interior
         if (height > 0)
         {
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
index dbf36818b..7cccfe222 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBed.java
@@ -3,14 +3,15 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.block.BlockBed;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicBed;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 
-public class BlockModelBed<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelBed<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate underTexture = TextureRegistry.getTexture("minecraft:block/bed/bottom");
-    public BlockModelBed(Block block) {
+    public BlockModelBed(Block<T> block) {
         super(block);
         atlasIndices[0] = TextureRegistry.getTexture("minecraft:block/bed/foot_front");
         atlasIndices[1] = TextureRegistry.getTexture("minecraft:block/bed/foot_side");
@@ -27,8 +28,8 @@ public class BlockModelBed<T extends Block> extends BlockModelStandard<T> {
         renderBlocks.cache.setupCache(block, renderBlocks.blockAccess, x, y, z);
 
         final int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
-        final int direction = BlockBed.getDirection(meta);
-        final boolean isFootOfBed = BlockBed.isBlockFootOfBed(meta);
+        final int direction = BlockLogicBed.getDirection(meta);
+        final boolean isFootOfBed = BlockLogicBed.isBlockFootOfBed(meta);
 
         final double minY = bounds.minY;
         bounds.minY += 0.1875D;
@@ -50,7 +51,7 @@ public class BlockModelBed<T extends Block> extends BlockModelStandard<T> {
         renderSide(tessellator, bounds, x, y, z, Side.TOP, meta);
 
         renderBlocks.uvRotateTop = 0;
-        final int f17 = isFootOfBed ? BlockBed.headOfBedMap[BlockBed.footToHeadMap[direction]] : BlockBed.headOfBedMap[direction];
+        final int f17 = isFootOfBed ? BlockLogicBed.headOfBedMap[BlockLogicBed.footToHeadMap[direction]] : BlockLogicBed.headOfBedMap[direction];
 
         if(f17 != 2 && (renderBlocks.renderAllFaces || shouldSideBeRendered(renderBlocks.blockAccess, bounds, x, y, z - 1, 2)))
         {
@@ -88,9 +89,9 @@ public class BlockModelBed<T extends Block> extends BlockModelStandard<T> {
         if(side == Side.BOTTOM) {
             return underTexture;
         }
-        int k = BlockBed.getDirection(data);
-        int l = BlockBed.bedDirection[k][side.getId()];
-        if(BlockBed.isBlockFootOfBed(data)) {
+        int k = BlockLogicBed.getDirection(data);
+        int l = BlockLogicBed.bedDirection[k][side.getId()];
+        if(BlockLogicBed.isBlockFootOfBed(data)) {
             if(l == 2) {
                 return atlasIndices[3];
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
index 85baf689f..e19c412a0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelBrazier.java
@@ -4,21 +4,21 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicBrazier;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.block.BlockBrazier;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelBrazier<T extends BlockBrazier>
+public class BlockModelBrazier<T extends BlockLogicBrazier>
     extends BlockModelStandard<T> {
     protected IconCoordinate sideTexture = TextureRegistry.getTexture("minecraft:block/brazier/side");
     protected IconCoordinate baseTexture = TextureRegistry.getTexture("minecraft:block/brazier/base");
-    protected BlockModelStandard<Block> fireModel = new BlockModelFire<>(Blocks.FIRE, true).withTextures("minecraft:block/fire");
+    protected BlockModelStandard<?> fireModel = new BlockModelFire<>(Blocks.FIRE, true).withTextures("minecraft:block/fire");
 
-    public BlockModelBrazier(Block block) {
+    public BlockModelBrazier(Block<T> block) {
         super(block);
     }
 
@@ -44,7 +44,7 @@ public class BlockModelBrazier<T extends BlockBrazier>
         renderSide(tessellator, bounds, x, y - 1, z, Side.TOP, 0);
         renderBlocks.enableAO = false;
 
-        if (block.isBurning()) {
+        if (block.getLogic().isBurning()) {
             fireModel.render(tessellator, x, y, z);
         }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
index 0cdb12c72..44b362410 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCactus.java
@@ -3,13 +3,14 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelCactus<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelCactus(Block block) {
+public class BlockModelCactus<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelCactus(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
index 8f3e9b25a..aab08a3ed 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCake.java
@@ -3,11 +3,12 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelCake<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelCake<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate cakeInner = TextureRegistry.getTexture("minecraft:block/cake/inner");
-    public BlockModelCake(Block block) {
+    public BlockModelCake(Block<T> block) {
         super(block);
         float f = 0.0625F;
         float f1 = 0.5F;
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
index 1ee54fd96..074da2f85 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCandle.java
@@ -3,10 +3,11 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelCandle<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelCandle(Block block) {
+public class BlockModelCandle<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelCandle(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
index 07958e0e4..6833192a8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChest.java
@@ -3,12 +3,13 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockChest;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicChest;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelChest<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelChest<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate chestFrontSingle;
     protected IconCoordinate chestFrontLeft;
     protected IconCoordinate chestFrontRight;
@@ -16,7 +17,7 @@ public class BlockModelChest<T extends Block> extends BlockModelStandard<T> {
     protected IconCoordinate chestBackRight;
     protected IconCoordinate chestSide;
     protected IconCoordinate chestTop;
-    public BlockModelChest(Block block, String rootKey) {
+    public BlockModelChest(Block<T> block, String rootKey) {
         super(block);
         chestFrontSingle = TextureRegistry.getTexture(rootKey + "front");
         chestFrontLeft = TextureRegistry.getTexture(rootKey + "left_front");
@@ -35,15 +36,15 @@ public class BlockModelChest<T extends Block> extends BlockModelStandard<T> {
             return chestTop;
         }
 
-        Side facing = BlockChest.getDirectionFromMeta(meta).getSide();
-        BlockChest.Type type = BlockChest.getTypeFromMeta(meta);
+        Side facing = BlockLogicChest.getDirectionFromMeta(meta).getSide();
+        BlockLogicChest.Type type = BlockLogicChest.getTypeFromMeta(meta);
 
-        if(type == BlockChest.Type.SINGLE) {
+        if(type == BlockLogicChest.Type.SINGLE) {
             if(side == facing) {
                 return chestFrontSingle;
             }
         }
-        if(type == BlockChest.Type.LEFT) {
+        if(type == BlockLogicChest.Type.LEFT) {
             if(side == facing) {
                 return chestFrontLeft;
             }
@@ -51,7 +52,7 @@ public class BlockModelChest<T extends Block> extends BlockModelStandard<T> {
                 return chestBackRight;
             }
         }
-        if(type == BlockChest.Type.RIGHT) {
+        if(type == BlockLogicChest.Type.RIGHT) {
             if(side == facing) {
                 return chestFrontRight;
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
index 3404a4fcc..fb8b6435e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelChestPainted.java
@@ -3,13 +3,14 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockChest;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicChest;
 import net.minecraft.core.util.helper.Axis;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
-public class BlockModelChestPainted<T extends Block> extends BlockModelChest<T> {
+public class BlockModelChestPainted<T extends BlockLogic> extends BlockModelChest<T> {
     public static final IconCoordinate[][] texCoords = new IconCoordinate[DyeColor.COLOR_AMOUNT][];
     public static final int TEX_SINGLE_FRONT = 0;
     public static final int TEX_LEFT_FRONT = 1;
@@ -32,7 +33,7 @@ public class BlockModelChestPainted<T extends Block> extends BlockModelChest<T>
             texCoords[c.blockMeta][TEX_TOP] = TextureRegistry.getTexture(rootKey + "top");
         }
     }
-    public BlockModelChestPainted(Block block) {
+    public BlockModelChestPainted(Block<T> block) {
         super(block, "minecraft:block/chest/planks/");
     }
 
@@ -45,15 +46,15 @@ public class BlockModelChestPainted<T extends Block> extends BlockModelChest<T>
             return texCoords[color][6];
         }
 
-        Side facing = BlockChest.getDirectionFromMeta(meta).getSide();
-        BlockChest.Type type = BlockChest.getTypeFromMeta(meta);
+        Side facing = BlockLogicChest.getDirectionFromMeta(meta).getSide();
+        BlockLogicChest.Type type = BlockLogicChest.getTypeFromMeta(meta);
 
-        if(type == BlockChest.Type.SINGLE) {
+        if(type == BlockLogicChest.Type.SINGLE) {
             if(side == facing) {
                 return texCoords[color][TEX_SINGLE_FRONT];
             }
         }
-        if(type == BlockChest.Type.LEFT) {
+        if(type == BlockLogicChest.Type.LEFT) {
             if(side == facing) {
                 return texCoords[color][TEX_LEFT_FRONT];
             }
@@ -61,7 +62,7 @@ public class BlockModelChestPainted<T extends Block> extends BlockModelChest<T>
                 return texCoords[color][TEX_RIGHT_BACK];
             }
         }
-        if(type == BlockChest.Type.RIGHT) {
+        if(type == BlockLogicChest.Type.RIGHT) {
             if(side == facing) {
                 return texCoords[color][TEX_RIGHT_FRONT];
             }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
index 9112fc166..3a332973e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
@@ -5,9 +5,10 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelCropsPumpkin<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] GROWTH_STAGE_TEXTURES_TOP = {
             TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage1_top"),
             TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage2_top"),
@@ -23,7 +24,7 @@ public class BlockModelCropsPumpkin<T extends Block> extends BlockModelStandard<
 
     public static final IconCoordinate LEAF_TEXTURE = TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage0");
 
-    public BlockModelCropsPumpkin(Block block) {
+    public BlockModelCropsPumpkin(Block<T> block) {
         super(block);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
index 812b707f6..0b50edcf6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
@@ -5,11 +5,12 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.block.BlockCropsWheat;
+import net.minecraft.core.block.BlockLogic;
+import net.minecraft.core.block.BlockLogicCropsWheat;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 
-public class BlockModelCropsWheat<T extends Block> extends BlockModelStandard<T> {
+public class BlockModelCropsWheat<T extends BlockLogic> extends BlockModelStandard<T> {
     public final IconCoordinate[] growthStageTextures = {
             TextureRegistry.getTexture("minecraft:block/crops_wheat/stage0"),
             TextureRegistry.getTexture("minecraft:block/crops_wheat/stage1"),
@@ -21,9 +22,9 @@ public class BlockModelCropsWheat<T extends Block> extends BlockModelStandard<T>
             TextureRegistry.getTexture("minecraft:block/crops_wheat/stage7")
     };
 
-    public BlockModelCropsWheat(Block block) {
+    public BlockModelCropsWheat(Block<T> block) {
         super(block);
-        assert growthStageTextures.length == BlockCropsWheat.MAX_GROWTH_STATE + 1 : "There must be a texture for each wheat growth stage!";
+        assert growthStageTextures.length == BlockLogicCropsWheat.MAX_GROWTH_STATE + 1 : "There must be a texture for each wheat growth stage!";
     }
 
     @Override
@@ -98,6 +99,6 @@ public class BlockModelCropsWheat<T extends Block> extends BlockModelStandard<T>
     @Override
     public IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
     {
-        return growthStageTextures[MathHelper.clamp(data, 0, 7)];
+        return growthStageTextures[MathHelper.clamp(data, 0, BlockLogicCropsWheat.MAX_GROWTH_STATE)];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index 6a7e29510..fbabfa513 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -5,13 +5,14 @@ import net.minecraft.client.render.block.color.BlockColorDispatcher;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
 
-public class BlockModelCrossedSquares<T extends Block> extends BlockModelStandard<T> {
-    public BlockModelCrossedSquares(Block block) {
+public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelStandard<T> {
+    public BlockModelCrossedSquares(Block<T> block) {
         super(block);
     }
     @Override
